/*

   FILE:
	artis_conf.h

   Copyright (C) 1998-2003
        GTI-IA, DSIC, UPV


  This is free software;  you can  redistribute it  and/or modify it under
  terms of the  GNU General Public License as published  by the Free Soft-
  ware  Foundation;  either version 2,  or (at your option) any later ver-
  sion.  It is distributed in the hope that it will be useful, but WITH-
  OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  for  more details.  You should have  received  a copy of the GNU General
  Public License;  see file COPYING.  If not, write to  the Free Software
  Foundation,  59 Temple Place - Suite 330,  Boston, MA 02111-1307, USA.

*/

/*

  AUTHOR(S): A. Terrasa

  CREATION DATE: 2003-10-16

  CHANGELOG:


  DESCRIPTION:
  
  Global configuration for the ARTIS prototype. It contains some
  definitions which configure the prototype at compile time (for
  example, meta-reasoning support, number of internal mutexes, etc.).

  In future versions, this file should be automatically generated by a
  global configuration Makefile (make xconfig) or similar.


*/

#ifndef __ARTIS_CONF_H
#define __ARTIS_CONF_H



#define ARTIS_FIRST_MUTEX  256
#define ARTIS_LAST_MUTEX   512

#define ARTIS_CONF_METAREASONING
#define ARTIS_CONF_METAREASONING_WAKEUP   ///<
#define ARTIS_CONF_METAREASONING_REACT_DEGREE   ///< To allow Reactivity Degree
#define ARTIS_CONF_METAREASONING_BEHAVS   ///< To allow behaviours 
///#define ARTIS_CONF_AUTO_METAREASONING 


/// Debug Options

#define ARTIS_TRACE_EVENTS

///#define ARTIS_INIT_DEBUG

//#define ARTIS_CONF_CORE_DEBUG

#define ARTIS_CONF_EVENTS_DEBUG_0   ///< To generate the kiwi trace.
///#define ARTIS_CONF_EVENTS_DEBUG_1   ///< To generate text debug messages.
///#define ARTIS_CONF_EVENTS_DEBUG_2   ///< To generate more text debug messages.

///#define ARTIS_CONF_DS_DEBUG_1
///#define ARTIS_CONF_DS_DEBUG_2

///#define ARTIS_CONF_META_RULE_DEBUG_1

#define ARTIS_CONF_RS_DEBUG_0       ///< To generate the kiwi trace
//#define ARTIS_CONF_RS_DEBUG_1       ///< To generate generic text debug messages
///#define ARTIS_CONF_RS_DEBUG_2       ///< To generate mode-change text debug messages




#define ARTIS_LAST_NONUSER_ENTITY 1      /// Includes the metaclass.


#define RTLINUX_ONLY  // When there's no Linux side (remove in final version)

#define COMO


/// MANDATORY Section: Used by DS
#define INI_MANDATORY_T  4250000
#define INI_MANDATORY_CT  100000
#define INI_MANDATORY_R  1000000
#define INI_MANDATORY_S  1000000
#define INI_MANDATORY_I  1000000
#define INI_MANDATORY_C  3000000

#define WCET_KDM_ACCESS    20000


#define MUTEX_CONTROL 333
#define MUTEX_EM 333

#endif




