/*

   FILE:
	artis_mutex_definition.h

   Copyright (C) 1998-2003
        GTI-IA, DSIC, UPV


  This is free software;  you can  redistribute it  and/or modify it under
  terms of the  GNU General Public License as published  by the Free Soft-
  ware  Foundation;  either version 2,  or (at your option) any later ver-
  sion.  It is distributed in the hope that it will be useful, but WITH-
  OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  for  more details.  You should have  received  a copy of the GNU General
  Public License;  see file COPYING.  If not, write to  the Free Software
  Foundation,  59 Temple Place - Suite 330,  Boston, MA 02111-1307, USA.

*/

/*

  AUTHOR(S): A. Terrasa

  CREATION DATE: 2003-10-16

  CHANGELOG:


  DESCRIPTION:
  
  This file exports the identifiers for the mutexes used in ARTIS
  modules (such as the KDM, for instance).

  The mutex identifiers reserved for the end user are numbered after
  0, while these "internal" mutexes are numbered after
  "FIRST_ARTIS_MUTEX", defined in "./artis_conf.h"


*/

#ifndef __ARTIS_MUTEX_DEFINITION_H
#define __ARTIS_MUTEX_DEFINITION_H

#include <artis_conf.h>



/*
  Place here the mutex definitions for the ARTIS modules,
  numbered after FIRST_ARTIS_MUTEX
*/


/*
  For example: 

#define MUTEX_KDM_1   (FIRST_ARTIS_MUTEX)
#define MUTEX_KDM_2   (FIRST_ARTIS_MUTEX+1)   

*/



#endif // #ifndef__ARTIS_MUTEX_DEFINITION_H



