/// Functions are only compiled if the -DDEBUG flag is present

#include "debug.h"

#ifdef DEBUG
static linkedlist debug_log;
#endif


/// Clean a text string
void blank(char msg[TEXT_LENGTH]) {
#ifdef DEBUG
	int i;
	
	for ( i = 0 ; i < strlen(msg) ; i++ ) {
		msg[i] = '\0';
	}
	
	return;
#endif
}

void debug_start() {
#ifdef DEBUG
	int i;
	initlist(debug_log);
	i = addnode(debug_log);
        setcode(debug_log, i, 0);
        setmsg(debug_log, i, "Starting Debug...");
	return;
#endif
}

void debug_print(char *msg, int code) {
//#ifdef DEBUG
	int i;
	
	//return;  // We don't want no stinkin' debug !!!

	/// Print out message
	fprintf(stderr, "DEBUG: %d: %s\n",code, msg);
	
	/*i = addnode(debug_log);
        setcode(debug_log, i, code);
        setmsg(debug_log, i, msg);*/
	return;
//#endif
}

void debug_show_log() {
#ifdef DEBUG
	int i;
	int code;
	char msg[TEXT_LENGTH];
	
	for ( i = 1 ; i < len(debug_log) ; i++ ) {
		code = getcode(debug_log, i);
		getmsg(debug_log, i, msg);
		fprintf(stderr, "DEBUG (%d): %d: %s\n", i, code, msg);
		blank(msg);
	}
	return;
#endif
}
