#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdlib.h>
#include "mensaje.h"
#include "../debug.h"

#define TRUE 1
#define FALSE 0


void inicializar_campos_mensaje(Tmensaje * campos_mensaje){

  // Initialize the Tmensaje struct

  campos_mensaje->sender[0]='\0';
  campos_mensaje->receiver[0]='\0';
  campos_mensaje->reply_to[0]='\0';
  campos_mensaje->content[0]='\0';
  campos_mensaje->language[0]='\0';
  campos_mensaje->encoding[0]='\0';
  campos_mensaje->ontology[0]='\0';
  campos_mensaje->protocol[0]='\0';
  campos_mensaje->conversation_id[0]='\0';
  campos_mensaje->reply_with[0]='\0';
  campos_mensaje->in_reply_to[0]='\0';
  campos_mensaje->reply_by[0]='\0';
  campos_mensaje->x_subject[0]='\0';
  campos_mensaje->x_priority[0]='\0';
  campos_mensaje->tiempo_emision.tv_sec=0;
  campos_mensaje->tiempo_emision.tv_sec=0;
  campos_mensaje->tiempo_recepcion.tv_sec=0;
  campos_mensaje->tiempo_recepcion.tv_sec=0;
  //  timeclear(campos_mensaje->tiempo_emision);
  //timeclear(campos_mensaje->tiempo_recepcion);
}

/// Remove the timestamp from a message
///
/// Remove the timestamp from a message and return
/// it as time structures
/// @param msg String with the message
/// @param Tv_sec TTL in secs (long)
/// @param Tv_usec TTL in microsecs (long)
int quita_tiempo(char * msg,long * Tv_sec,long * Tv_usec){
/* // THIS CODE WAS LEFT HERE FOR HISTORICAL RESEARCH PURPOSES
  int i=0;
  int j=0;
  char  contenido [50];
  char * caracter_actual=msg;

 //Variables auxiliares para extraer el tiempo
  while (* caracter_actual!=' '){
     contenido[i]=*caracter_actual++;
     i++;
  }
  contenido[i]='\0';
  caracter_actual++;

  //printf("\n El contenido de i es %s\t%i",contenido,atoi(contenido));
  * Tv_sec=atol(contenido);

  i=0;
  while (* caracter_actual!=' '){
    contenido[i]=*caracter_actual++;
    i++;
  }  
  
  contenido[i]='\0';
  caracter_actual++;

  //printf("\n El contenido de tv_usec  es %s",contenido);
  * Tv_usec=atol(contenido);

  strcpy(msg,caracter_actual);
  */
  
  // EFFICIENT RE-IMPLEMENTATION
  
  int i = 0, j = 0, k=0, contenido = 0;
  char aux[TAM_CAMPO];
  char str_sec[TAM_ETIQUETA];
  char str_usec[TAM_ETIQUETA];
  char debug_aux[TAM_DEBUG];
  
  // Check if there's really a timestamp to remove
  if ( msg[0] != '(' ) contenido = 1;
  
  if ( contenido == 1 ) {
	sscanf(msg,"%s %s",str_sec,str_usec);
	while ( msg[i]!= '(' ) i++;  // Look for the starting '('
	for ( j=i ; j<strlen(msg) ; j++ ) {  // Copy only the FIPA segment to 'aux'
		aux[k] = msg[j];
		k++;
	}
	aux[k]='\0';
	strcpy(msg,aux);
	
	*Tv_sec=atol(str_sec);
	*Tv_usec=atol(str_usec);
	
	//DEBUG
	strcpy(debug_aux,"Tv_sec: ");
	strcat(debug_aux,str_sec);
	debug_print(debug_aux, 1);
	strcpy(debug_aux,"Tv_usec: ");
	strcat(debug_aux,str_usec);
	debug_print(debug_aux, 1);
	strcat(debug_aux,"contenido: ");
	if (contenido == 0) strcat(debug_aux,"0"); 
	else strcat(debug_aux,"1");
	debug_print(debug_aux, 1);
	strcpy(debug_aux,"Resto: ");
	strcat(debug_aux,msg);
	debug_print(debug_aux, 1);
  }
  
  return ERROR_NONE;
}


int extraer_campos_mensaje(char msg[], Tmensaje * campos_mensaje){

  char etiqueta [TAM_ETIQUETA];
  char contenido [TAM_CAMPO];
  int i=0;
  int j;
  int nivel=0;  // Nestig level (number of parenthesis).
  char * pos_actual; // Used in 'sender' to detect where the known ':name' tag starts 
  char aux[TEXT_LENGTH];

  debug_print("extraer_campos_mensaje: Start",2);
	
  if (strlen(msg)==0){
	debug_print("Error: void message", 2);
    return -1;
  }


  // Initialize the Tmensaje structure
  inicializar_campos_mensaje(campos_mensaje);

  // Remove unused characters
  quitar_caracteres_inutiles(msg);

  // Extract the timestamp
  quita_tiempo(msg,& campos_mensaje->tiempo_recepcion.tv_sec,& campos_mensaje->tiempo_recepcion.tv_usec);
  
  
  // Look for the starting parenthesis
  if (msg[i]!='('){
	strcpy(aux, "Error: Syntax error. '(' expected. Found: ");
	strcat(aux, msg);
	debug_print(aux, 2);
    return -1;
  }
  else {
    i++;
    nivel++;  // Increase the level
  }

  // Remove blanks, tabs y CRs
  if (msg[i]==' ') i++;

  // Read the performative (communicative act)
  j=0;
  while ((i<=strlen(msg)) && msg[i]!=' ' && msg[i]!=':'){
    campos_mensaje->performative[j]=tolower(msg[i]);
    i++;
    j++;
  }
  campos_mensaje->performative[j]='\0';
  //printf("\nperformative: %s",campos_mensaje->performative);

  // Remove blanks, tabs and CRs
   if (msg[i]==' ') i++;

  // Start the loop to read all the message tags
  while (i<strlen(msg)){
    // Look for the starting colon
    if (msg[i]!=':'){
	  debug_print("Error: Syntax error. ':' Expected", 2); 
      return -1;
    }
    else i++;

    // Read the tag characters
    j=0;
    while ((i<strlen(msg)) && msg[i]!=' '){
      etiqueta[j]=msg[i];
      i++;
      j++;
    }
    etiqueta[j]='\0';  // Add the \0 character
    
    // Remove remaining blank
	if (msg[i]==' ') i++;

    // Read the message
    j=0;
    
    while (i<strlen(msg) && ((msg[i]!=':') || (msg[i]==':' && nivel>1))){
      fflush(stdout);
      switch(msg[i]){
      case '(':
	nivel++;
	contenido[j]=msg[i];
	i++;
	j++;
	break;
      case ')':
	nivel--;
	if (nivel==0){
	  i++;
	  break;
	}
      default:
	contenido[j]=msg[i];
	i++;
	j++;
	break;
      }      
    }
   
    // If the last character is a blank, remove it
    if (contenido[j-1]==' '){
      contenido[j-1]='\0';
	}
    else
      contenido[j]='\0';


    // The registering process depends upon the tag:

    // If it's 'sender'
    if (strcmp(etiqueta,"sender")==0){
	    
      // The IP adress (or logic name) should be after ':name'
      if ((pos_actual=strstr(contenido,":name "))!=NULL){
	      
	// Advance to the actual data
	pos_actual=pos_actual+6;
	
	j=0;
	if (*pos_actual=='"')
		pos_actual++;

			
	while ((* pos_actual!='@') && (* pos_actual!=')') && (* pos_actual != '\0') && (* pos_actual != '"')){
	  campos_mensaje->sender[j++]= * pos_actual;
	  pos_actual++;
	};
	
      }
      
      if(pos_actual=='\0')
	strcpy(campos_mensaje->sender, contenido);

    }
    else if (strcmp(etiqueta,"receiver")==0){
      strcpy(campos_mensaje->receiver, contenido);
    }
    else if (strcmp(etiqueta,"reply-to")==0){
      strcpy(campos_mensaje->reply_to, contenido);
    }
    else if (strcmp(etiqueta,"content")==0){
      strcpy(campos_mensaje->content, contenido);
    }
    else if (strcmp(etiqueta,"language")==0){
      strcpy(campos_mensaje->language, contenido);
    }
    else if (strcmp(etiqueta,"encoding")==0){
      strcpy(campos_mensaje->encoding, contenido);
    }
    else if (strcmp(etiqueta,"ontology")==0){
      strcpy(campos_mensaje->ontology, contenido);
    }
    else if (strcmp(etiqueta,"protocol")==0){
      strcpy(campos_mensaje->protocol, contenido);
    }
    else if (strcmp(etiqueta,"conversation-id")==0){
      strcpy(campos_mensaje->conversation_id, contenido);
    }
    else if (strcmp(etiqueta,"reply-with")==0){
      strcpy(campos_mensaje->reply_with, contenido);
    }
    else if (strcmp(etiqueta,"in-reply-to")==0){
      strcpy(campos_mensaje->in_reply_to, contenido);
    }
    else if (strcmp(etiqueta,"reply-by")==0){
      strcpy(campos_mensaje->reply_by, contenido);
    }
    else if (strcmp(etiqueta,"x-subject")==0){
      strcpy(campos_mensaje->x_subject, contenido);
    }
    else if (strcmp(etiqueta,"x-priority")==0){
      strcpy(campos_mensaje->x_priority, contenido);
    }
  }
  debug_print("extraer_campos_mensaje: Fin",2);
  return 0;
}




void imprimir_campos_mensaje(Tmensaje campos_mensaje){
  char aux[TAM_DEBUG];
  // Look for the non-void tags and print them out
  debug_print("imprimir_campos_mensaje: Inicio",2);
  if (campos_mensaje.performative[0] != '\0'){
    strcpy(aux,"Performative: ");
    strcat(aux, campos_mensaje.performative);
    debug_print(aux,0);
  }
  if (campos_mensaje.sender[0] != '\0'){
    strcpy(aux,"Sender: ");
    strcat(aux, campos_mensaje.sender);
    debug_print(aux,0);  }
  if (campos_mensaje.receiver[0] != '\0'){
    strcpy(aux,"Receiver: ");
    strcat(aux, campos_mensaje.receiver);
    debug_print(aux,0);
  }
  if (campos_mensaje.reply_to[0] != '\0'){
    strcpy(aux,"Reply-To: ");
    strcat(aux, campos_mensaje.reply_to);
    debug_print(aux,0);
  }
  if (campos_mensaje.content[0] !='\0'){
    strcpy(aux,"Content: ");
    strcat(aux, campos_mensaje.content);
    debug_print(aux,0);
  }
  if (campos_mensaje.language[0] !='\0'){
    strcpy(aux,"Language: ");
    strcat(aux, campos_mensaje.language);
    debug_print(aux,0);
  }
  if (campos_mensaje.encoding[0] !='\0'){
    strcpy(aux,"Encoding: ");
    strcat(aux, campos_mensaje.encoding);
    debug_print(aux,0);
  }
  if (campos_mensaje.ontology[0] != '\0'){
    strcpy(aux,"Ontology: ");
    strcat(aux, campos_mensaje.ontology);
    debug_print(aux,0);
  }
  if (campos_mensaje.protocol[0] != '\0'){
    strcpy(aux,"Protocol: ");
    strcat(aux, campos_mensaje.protocol);
    debug_print(aux,0);
  }
  if (campos_mensaje.conversation_id[0] != '\0'){
    strcpy(aux,"Conversation_id: ");
    strcat(aux, campos_mensaje.conversation_id);
    debug_print(aux,0);
  }
  if (campos_mensaje.reply_with[0] != '\0'){
    strcpy(aux,"Reply-With: ");
    strcat(aux, campos_mensaje.reply_with);
    debug_print(aux,0);
}
  if (campos_mensaje.in_reply_to[0] != '\0'){
    strcpy(aux,"In-Reply-To: ");
    strcat(aux, campos_mensaje.in_reply_to);
    debug_print(aux,0);
  }
  if (campos_mensaje.reply_by[0] != '\0'){
    strcpy(aux,"Reply-By: ");
    strcat(aux, campos_mensaje.reply_by);
    debug_print(aux,0);
  }
  if (campos_mensaje.x_subject[0] != '\0'){
    strcpy(aux,"X-Subject: ");
    strcat(aux, campos_mensaje.x_subject);
    debug_print(aux,0);
  }
  if (campos_mensaje.x_priority[0] != '\0'){
    strcpy(aux,"X-Priority: ");
    strcat(aux, campos_mensaje.x_priority);
    debug_print(aux,0);
  }
  fflush(stdout);

  debug_print("imprimir_campos_mensaje: Fin",2);
}



int formar_mensaje(Tmensaje campos_mensaje, char mensaje[TAM_CAMPO]){
  char tiempo [50];
  
  debug_print("formar_mensaje: Incio",2);

  // The registering process depends upon the tag
  // If it's 'sender':
  mensaje[0]='\0';

  // Get system date
  gettimeofday( & campos_mensaje.tiempo_emision,NULL);

  // Put secs in message
  sprintf(tiempo,"%li %li",(long)campos_mensaje.tiempo_emision.tv_sec,(long)campos_mensaje.tiempo_emision.tv_usec);
  strcat(mensaje,tiempo);
  strcat(mensaje," ");


  // Add the rest of the fields to the message. The performative is mandatory
  if (campos_mensaje.performative[0] != '\0'){
    strcat(mensaje,"(");
    strcat(mensaje, campos_mensaje.performative);
  }

  if (campos_mensaje.sender[0] != '\0'){
	// Leave just the IP for the moment (the rest is commented out) 
	strcat(mensaje," :sender ");
    	strcat(mensaje, campos_mensaje.sender);
	strcat(mensaje," ");
  }
  if (campos_mensaje.receiver[0] != '\0'){
	// Leave just the IP for the moment (the rest is commented out) 
	strcat(mensaje," :receiver ");
    	strcat(mensaje, campos_mensaje.receiver);
	strcat(mensaje," ");
  }

  if (campos_mensaje.content[0]!='\0'){
    strcat(mensaje," :content ");
    strcat(mensaje, campos_mensaje.content);
  }
	
  if (campos_mensaje.reply_to[0] != '\0'){
    strcat(mensaje," :reply-to ");
    strcat(mensaje, campos_mensaje.reply_to);
  }
  if (campos_mensaje.language[0]!='\0'){
    strcat(mensaje," :language ");
    strcat(mensaje, campos_mensaje.language);
  }
  if (campos_mensaje.encoding[0] != '\0'){
    strcat(mensaje," :encoding ");
    strcat(mensaje, campos_mensaje.encoding);
  }
  if (campos_mensaje.ontology[0] != '\0'){
    strcat(mensaje," :ontology ");
    strcat(mensaje, campos_mensaje.ontology);
  }
  if (campos_mensaje.conversation_id[0] != '\0'){
    strcat(mensaje," :conversation-id ");
    strcat(mensaje, campos_mensaje.conversation_id);
  }
  if (campos_mensaje.reply_with[0] != '\0'){
    strcat(mensaje," :reply-with ");
    strcat(mensaje, campos_mensaje.reply_with);
  }
  if (campos_mensaje.in_reply_to[0] != '\0'){
    strcat(mensaje," :in-reply-to ");
    strcat(mensaje, campos_mensaje.in_reply_to);
  }
  if (campos_mensaje.reply_by[0] != '\0'){
    strcat(mensaje," :reply-by ");
    strcat(mensaje, campos_mensaje.reply_by);
  }
  if (campos_mensaje.protocol[0] != '\0'){
    strcat(mensaje," :protocol ");
    strcat(mensaje, campos_mensaje.protocol);
  }
  if (campos_mensaje.x_subject[0] != '\0'){
    strcat(mensaje," :x-subject ");
    strcat(mensaje, campos_mensaje.x_subject);
  }
  if (campos_mensaje.x_priority[0] != '\0'){
    strcat(mensaje," :x-priority ");
    strcat(mensaje, campos_mensaje.x_priority);
  }
  strcat(mensaje, " )");  // Add the closing parenthesis
  strcat(mensaje,"\0");
  
  // Remove the not needed characters
  quitar_caracteres_inutiles(mensaje);

  return 0;
}


void quitar_caracteres_inutiles(char msg[]){
  int ultimo_caracter_inutil=TRUE;
  char msg_nuevo[TAM_CAMPO];
  int i=0; // To iterate the initial string
  int j=0; // To iterate the final string
	
  while (i<strlen(msg)){
    switch (msg[i]){
    case ' ':
    case '\t':
    case '\n':
    case '\r':
      if (ultimo_caracter_inutil==FALSE){
	msg_nuevo[j++]=' ';
      }
      ultimo_caracter_inutil=TRUE;
      break;
    default:
      ultimo_caracter_inutil=FALSE;
      msg_nuevo[j++]=msg[i];
      break;
    }  // swith
    i++;
  }  // while
  
  msg_nuevo[j]='\0';
  strcpy(msg,msg_nuevo);  // Copy the messages

}  // function

/// Erase a message field
/// @param s The fild (char array)
void clear_msg_field(char *s) {
	int i;
	
	for ( i = 0 ; i < TAM_ETIQUETA ; i++ ) s[i] = '\0';
}

/// Erase ("clean") a message
/// @param m The message
void clear_msg(Tmensaje m) {
  	clear_msg_field(m.performative);
  	clear_msg_field(m.sender);
	clear_msg_field(m.receiver);
	clear_msg_field(m.reply_to);
	clear_msg_field(m.content);
	clear_msg_field(m.language);
	clear_msg_field(m.encoding);
	clear_msg_field(m.ontology);
	clear_msg_field(m.protocol);
	clear_msg_field(m.conversation_id);
	clear_msg_field(m.reply_with);
	clear_msg_field(m.in_reply_to);
	clear_msg_field(m.reply_by);
	clear_msg_field(m.x_subject);
	clear_msg_field(m.x_priority);
  	m.tiempo_emision.tv_sec = 0;
	m.tiempo_emision.tv_usec = 0;
  	m.tiempo_recepcion.tv_sec = 0;
	m.tiempo_recepcion.tv_usec = 0;
}
