
#ifndef TRANSPORTE_H
#define TRANSPORTE_H

#include <stdio.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/time.h>

#include "../global.h"
#include "../debug.h"

//#define SOCKET_ENVIAR 2000
#define SOCKET_RECIBIR 2001

//Definimos la constante q contedra la direccion IP del grupo multicast
//Su valor debe de estar comprendido entre 225.0.0.0 y 239.255.255.255. 
#define DIR_IP_GRUPO_MULTICAST "225.0.0.1"

typedef char buffer_msg[MSG_MAX_SIZE];

/// Vector de buffers de recepcion de mensajes de bajo nivel
//buffer_msg rcv_buffer[MAX_ROBOTS];

/// Envia un mensaje a traves de un socket
///
/// Funcion que envia un mensaje al destino especificado a traves de un socket. 
/// @param msg El mensaje a enviar
/// @param dst Destino
/// @return Numero de caracteres realmente enviados
int enviar_udp(char *  msg, char * dst);


/// Recibe un mensaje
///
/// Funcion que recibe un mensaje a traves de un socket. 
/// @param msg El mensaje a recibir
/// @param dir_cliente Direccion del cliente
/// @return Numero de caracteres realmente leidos
int recibir_udp(char * msg, char * dir_cliente);


/// Inicializa la red
///
/// Funcion que inicializa el servicio de red por UDP
int inicializar_udp();


/// Obtiene la direccion IP del servidor
///
/// Funcion que obtiene la direccion IP del servidor
/// @return Una cadena con la direccion IP principal del servidor
char * obtener_dir_ip_servidor();

#endif

