
#ifndef RED_H
#define RED_H

#include <stdio.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/time.h>
#include "./nivel_transporte/transporte.h"
#include "./mensaje/mensaje.h"
#include "global.h"
#include "debug.h"


/// Enviar un mensaje
///
/// Funcion que se encarga de enviar un mensaje (msg) a traves de un socket conectado con destino.
/// Si el socket no existe lo crea.
/// @param campos_mensaje Mensaje a enviar
/// @return Numero de caracteres enviados
int enviar(Tmensaje campos_mensaje);


/// Recibir datos
///
/// Funcion que recibe datos a traves de un socket
/// Comprueba si esta conectado. En caso contrario lo conecta.
/// Lee del socket ya conectado
/// @param campos_mensaje Mensaje a recibir
/// @return Numero de caracteres leidos
int recibir(Tmensaje * campos_mensaje);


/// Inicializar red
///
/// Funcion que recibe datos a traves de un socket
int inicializar_red();


/// Devuelve la propia direccion IP
///
/// Devuelve la direccion ip de la maquina sobre la que esta oyendo el servidor
/// @param direccion Cadena pasada por referencia donde almacenar la direccion obtenida
void obtener_mi_direccion_ip(char * direccion);

#endif

