#include "types.h"


int initlist(linkedlist l) {
	int i;
	
	// Inicializamos el primer elemento como la cabecera
	strcpy(l[0].msg, "\0");
	l[0].code = 0;  // Usaremos el code de este nodo como el
						   // tamanyo de la lista
	
	for ( i = 1 ; i < MAX_VECTOR ; i++ ) {
		strcpy(l[i].msg, "\0");
		l[0].code = 0;	
	};
	
	return ERROR_NONE;
}

void printlist(linkedlist l) {
	int i;
	
	fprintf(stderr, "============\n");
	fprintf(stderr, "Cabecera\n");
	fprintf(stderr, "------------\n");
	fprintf(stderr, "SIZE: %d\n",l[0].code);
	fprintf(stderr, "============\n");
		
	for ( i = 1 ; i <= l[0].code ; i++) {
		fprintf(stderr, "Nodo %d\n",i);
		fprintf(stderr, "------------\n");
		fprintf(stderr, "CODE: %d\n",l[i].code);
		fprintf(stderr, "MESG: %s\n",l[i].msg);
		fprintf(stderr, "============\n");
	}
}

int addnode(linkedlist l) {
	l[0].code++;
	if (l[0].code == MAX_VECTOR)
		l[0].code = 1;
	return l[0].code;
}

int setcode(linkedlist l, int index, int c) {
	l[index].code = c;
	
	return ERROR_NONE;
}

int setmsg(linkedlist l, int index, char m[TEXT_LENGTH]) {
	strcpy(l[index].msg, m);
	
	return ERROR_NONE;
}

int len(linkedlist l) {
	return l[0].code;
}

int getcode(linkedlist l, int index) {
	return l[index].code;
}

void getmsg(linkedlist l, int index, char receiver[TEXT_LENGTH]) {
	strcpy(receiver, l[index].msg);
}

int copynode(linkedlist l, int dest, int orig) {
	l[dest].code = l[orig].code;
	strcpy(l[dest].msg, l[orig].msg);
	
	return ERROR_NONE;
}
