
#ifndef TYPES_H
#define TYPES_H

/*
################ TODO ################
 - Incluir buen tratamiento de errores
######################################
*/

#include <stdio.h>
#include <string.h>

#define MAX_VECTOR 255
#define TEXT_LENGTH 1024
#define LIST_LENGTH 1024
#define ERROR_NONE 0

/// Nodo de una lista enlazada
typedef struct lnode_ {
	char msg[TEXT_LENGTH];
	int code;
} lnode;

/// Lista enlazada estatica
typedef lnode linkedlist[MAX_VECTOR];

/// Inicializa una lista
///
/// @param l Lista por iniciar
int initlist(linkedlist l);

/// Imprime una lista
///
/// @param l Lista a imprimir
void printlist(linkedlist l);

/// Devuelve el indice del siguiente nodo libre de la lista
///
/// @param l Lista enlazada
int addnode(linkedlist l); 

/// Fija un codigo en un nodo
///
/// @param l Lista enlazada
/// @param index Indice del nodo
/// @param c Codigo deseado
int setcode(linkedlist l, int index, int c);

/// Fija un mensaje en un nodo
///
/// @param l Lista enlazada
/// @param index Indice del nodo
/// @param m Mensaje deseado
int setmsg(linkedlist l, int index, char m[TEXT_LENGTH]);

/// Obtiene el codigo de un nodo
///
/// @param l Lista enlazada
/// @param index Indice del nodo
/// @return El codigo del nodo
int getcode(linkedlist l, int index);

/// Obtiene el mensaje de un nodo
///
/// @param l Lista enlazada
/// @param index Indice del nodo
/// @param receiver Cadena de texto donde almacenar el mensaje
void getmsg(linkedlist l, int index, char receiver[TEXT_LENGTH]);

/// Obtiene la longitud de una lista
///
/// @param l Lista enlazada
/// @return La longitud
int len(linkedlist l);

/// Copia un nodo a otra posicion de la misma lista
///
/// @param l Lista enlazada
/// @param dest Indice del nodo destino
/// @param orig Indice del nodo origen
int copynode(linkedlist l, int dest, int orig);

#endif
