/******************************************************************************
 ***                 protos.h         01-08-95
 *** 
 *****************************************************************************/



void init(/*l_mks *lmks*/);            /*** Initialize agendas.           ***/

void  insert_mks(/*l_mks *lmks, mks *new_mks*/);   /*** It adds a new agent 
                                         *   into an agenda.
                                         ***/
mks *out_mks(/*l_mks *lmks*/);           /*** Extracts an agent an returns a
                                         *   pointer to it.
                                         ***/
                                    
void in_ord(/*l_mks *lmks, mks *new_mks*/);/*** It calls to one of the following
                                         *   functions depending upon the 
                                         *   current heuristic.
					 ***/
void in_ord_by_importance(/*l_mks *lmks, mks *new_mks*/);
                                        /*** It adds an agent in an ordered
                                         *   by importance manner. Upper to 
                                         *   lower importance.
                                         ***/
void in_ord_by_deadline(/*l_mks *lmks, mks *new_mks*/);
                                        /*** It adds an agent in an ordered
                                         *   by deadline manner. Lower to 
                                         *   upper deadline.
                                         ***/ 
void  free_mks(/*mks *old_mks*/);        

void  free_l_mks(/*l_mks *lmks*/);   

void in_ord( /*l_mks *lmks, mks *new_mks */);

mks *first(/*l_mks *lmks */);

mks *prev(/*l_mks *lmks */);

mks *last(/*l_mks *lmks */);

void in_hole(/*systime_t ls, systime_t t_deliber*/);

void in_first(/*l_mks *lmks, mks *new_mks*/);

void free_hole();

mks *mks_search(/*l_mks *lmks */);

void free_l_allocat(/*l_mks *lmks */);

void in_sched(/* int mksn, systime_t mks_time */);

void reset_t_deliber(/*l_mks *lmks, int mksn, systime_t last, systime_t *add */);

void  free_l_ks(/*n_ks *nks*/);      /*** They free memory as indicated by
		                         *   their parameters.
                                         ***/
int   update_mks(/*mks  *curr_mks*/);       /*** It updates the current ks of an 
                                         *   agent to the next ks if it exists,
                                         *   ( if not it returns 0), and upda-
					 *   tes the agent quality.
                                         ***/
mks *element_number( /*lmks, position*/ );  
                                        /*** It updates 'n_actual' with the
					 *   agent which is in 'la' and posi-
					 *   tion 'position'.
					 ***/
void  out_current( /*mks * */ );     /*** It extracts 'n_actual' from 'la'.
		                          ***/

void init_l_ks();                      /*** It initailizes the one and only
                                         *   global ksi list. 
                                         ***/
void in_l_ks(/*ks *ks*/);            /*** It adds a new ks into 'l_ksi'.***/

void free_ks(/*ks *ks*/);            /*** It frees memory.              ***/

mks *first( /*l_mks *lmks*/);         /*** Returns a pointer to the first agent
                                         *    in the la list, and initializes
                                         *    the n_actual global variable.
                                         ***/

mks *next( /*l_mks *lmks*/);          /*** Returns a pointer to the next agent
                                         *    in the list that is being currently
                                         *    managed, and it is based in the
                                         *    n_actual variable, which is
                                         *    acutalized by this function too.
                                         ***/
int paused (/* mks* */);              /***Returns either an agent KSI is paused
	                                 *  or not.
					 ***/
int not_executed(/* mks* */);         /***Returns either an agent KSI is still
		                         *  not executed or not.
					 ***/            
int id_ks(/* mks* */);               /***Returns pid assigned to a KSI when it
	                                 *  first is executed.
					 ***/
char *ks_name(/* mks* */);             /***Returns the KS name. ***/

void update_paused(/* mks *, int */); /***Update the agent state to indicate
		                         *  that its KSI has been paused.
					 ***/

void deadline(/*mks systime_t* */);          /***Returns agent actual ksi deadline.
					 ***/

#ifdef CONTROL_DEBUG
  void initialize_table();
#endif

