/********************** em.h ***********************************
 ********************** 20040809 *******************************/

#ifndef IS_H
#define IS_H


#include "sls.h"

///#include "../../include/metareasoning.h"

/*** #include "time_control4.0.h"  Para los MANDATORY ***/

#define TRIGGER_ERROR     5
#define TRIGGER_NOTIME_ER 4   /// No time for the current Event Rate
#define TRIGGER_NOTIME    3
#define TRIGGER_EMPTY     2    /*** The Event Store is empty ***/
#define TRIGGER_OK        1
#define TRIGGER_EXIT      0

/*** This constant is to return the control to the FLS in any situation except the end of the application ***/
#define IS_SLEEPING 1
#define IS_NOTIME   2

/********************/
/***/
/***#define METAREASONING***/
/********************/



/// Time points declaration 20040809
/*** Mandatory  trigger execution time. This is a estimation based on worst
 *   execution time of this function.
 ***/

extern systime_t MANDATORY_CT;
/*** Mandatory  condition_testing execution time. This is a estimation based on
 *    worst execution time of this function.
 ***/
extern systime_t MANDATORY_R;
/*** Mandatory  rating execution time. This is a estimation based on worst
 *   execution time of this function.
 ***/
extern systime_t MANDATORY_S;
/*** Mandatory  scheduling execution time. This is a estimation based on worst
 *   execution time of this function.
 ***/
extern systime_t MANDATORY_I;
/*** Mandatory interpreting execution time. This is a estimation based on worst
 *   execution time of this function.
 ***/
extern systime_t MANDATORY_T;

extern systime_t MIN_RUNTIME;  /// execute_until gives problems with 50 ms

extern systime_t control_slack; 
/*** It keeps the available time for Control. ***/

extern systime_t  real_time;
/*** It keeps the last moment in which control 
 *   called get_real_time().
 ***/

extern systime_t end_time;
/*** It keeps the moment in which Control has to terminate current invocation.
 ***/

extern systime_t init_time ;
/*** It keeps the moment in which Control began it's execution or the moment
 *   in which Control begins a new loop.
 ***/
extern systime_t origin;
/*** It keeps the moment in which Control was activated for first time.
 ***/

/// end timepoints declaration 20040809





void init_periodic_list();

void init_sporadic_list();

void init_rule_array();


/*** This creates a ks, it inserts the ks into 'l_ksi' so that this list 
 *   will be inserted into the agent structure (see trigger_...()).
 ***/
void set_deadline(/*id_ks, deadline, duration*/);


/*** This function activates the sporadic agents. ***/
void trigger_mks(/*mks_id, importance*/);


/*** Control will always be executed (or resumed) after the initial part of a 
 *   periodic agent, S.O. sends an event to pass control the avalable slack
 *   and this periodic agent, so control activates the agent (creating and 
 *   inserting it into the triggered agenda) and updates 'control_slack'.
 ***/
void trigger_periodic_mks(/*mks_id, deadline, slack*/);
/*** All of these functions will be called from CONTROL_KS() generated in 
 *   the semantic analysis.
 ***/

 

/*** It consults and updates some KS slots in order not to keep an obsolete
 *   KS.
 ***/
int  check_deadline(/*mks *mks*/);		                       
 
/*** Initialises some Control structures such subagendas and so on. ***/ 
void init_control(/* char * arg[] */);

/*** It reads events and invoques CONTROL_KS(). ***/
int  trigger(/*** systime_t end_time ***/);

/*** Perform check deadline tests. ***/
void  condition_testing();

/*** Executes or resumes selected agent's actual KS. ***/
void interpret_end(/* mks *, int */);


void update_rsa_deadlines();

/*** Gives back execution to First Level Scheduler. ***/
/*   void stop_control(); not declared as is a macro. */


/////// CreateStructures ////////
in_agent *create_in_agent(char*, int, int);
n_in_agent *insert_in_agent(in_agent*, n_in_agent*);
void in_mks_at_in_agent(in_agent*, mks*);
mks *create_mks(char*, int, char*, char*, int, int, in_agent*);
ks *create_ks(char*, int, systime_t, float);
void insert_ks(ks*, mks*);
/////////////////////////////////

#ifdef CONTROL_DEBUG
 int sfd;
#endif

#endif

