/********************** sls_policies.h **************************
 ********************** 20020220 ********************************/

#ifndef SLS_POLICIES_H
#define SLS_POLICIES_H

#include "../dserver/decl.h"

#include "../dserver/time_control.h"

#include "../dserver/III_strategy.h"

/*** Second Level Scheduling Policies ***/
#define BIF 1
#define EDF 0
#define DBS 2
#define III 3

#define NSLS 2


/********************************************************
 *            Private functions
 ********************************************************/



void time_to_assign();

void algorithm_selection();

ks *look_best();

hole *best_hole();

void AC_update();

void AC_calculate();

void optimize_hole();

void Dean_Boddy_Strategy();

mks *schedule_by_DBS();

mks *schedule_by_III();

mks *schedule_by_deadline();

mks *schedule_by_importance();

int ExecuteKSI_dbs();

#endif
