/**************************************************************************
 *
 *                   sls.c
 *                   Second Level Scheduler
 *                   20020104
 *
 **************************************************************************/

/**************************************************************************/
#include "../include/dserver/sls.h"
/**************************************************************************/
#include "../include/dserver/agenda.h"
#include "../include/dserver/em.h"
#include "../../include/time.h"
#include <stdio.h>





/* ============================================================================ */
void rating(int int_type){
/* ============================================================================ */

  mks *mks_curr ;
  int new_mks=0 ;
  systime_t max, t1;
  
#ifdef LUIS_DEBUG 
  fprintf(stderr,"\t(control.c) Rating ... \n" );
#endif
  
  if (((heuristic == III)||(heuristic==EDF)||(heuristic==DBS))
      &&(ctsa.number_mks)&&(rsa.number_mks))
    update_rsa_deadlines();
  
  while ((mks_curr=out_mks(&ctsa))!=(mks *)NULL ){
    /*** We suppose that when we pull out an agent of the rsa
     *    we kill it , then all the agents on the ctsa won't
     *    have any ksi executed, for that its quality  will
     *    be 0, because :
     *      quality = ( number_of_ks_executed / number_of_ks )
     *                    * importance 
     *      and number_of_ks_executed = 0
     ***/

    if (check_deadline(mks_curr)){
      if (heuristic==DBS)
	max= max < mks_curr->p_ks->KS->deadline ?
	  mks_curr->p_ks->KS->deadline : max;
#ifdef LUIS_DEBUG
      fprintf(stderr,"\t(control.c:rating) ag id:%s  ks:%d\n", 
	      mks_curr->name, 
	      mks_curr->p_ks->KS->identifier);
#endif 
      
      /*** This check_deadline inmediately before condition_testing is left here
       *   just in case we add new conditions into this function, and because
       *   is recommended to check deadlines every time we access an agenda.
       ***/
      new_mks=1;
      in_ord( &rsa, mks_curr );
    }
  }  /*** while ***/
  if ((heuristic == DBS) && (max > init_deadline) 
      && (Is_init_deadline!= -1)){
    t1= max - init_deadline;
    reset_t_deliber(&rsa,NEW_AGENT,t1,&t1);
    init_deadline=max + t1;
    Is_init_deadline=0;
  }
  /* fprintf(stderr,"rating: rsa agents: %d\n", rsa.number_mks);*/
  if (heuristic==DBS) Dean_Boddy_Strategy();
  if (heuristic==III) /// LUIS H.: WHERE IS IT?  III_strategy(new_mks, int_type)
    ;
}  /*** rating() ***/


/* ============================================================================ */
mks *schedule(){
/* ============================================================================ */
  /*** It executes one of the available scheduling algorithms according to a
   *    global variable that may have been initialized by the user.
   ***/
  mks *mks_sched;
  
#ifdef LUIS_DEBUG
  fprintf(stderr,"Scheduling.....\n");
  /*  fprintf(stderr,"number of sched ..%d \n",rsa.number_mks);*/
#endif
  
  if (rsa.number_mks==0) return ((mks *)NULL);
  switch ( heuristic ){
  case EDF : mks_sched=schedule_by_deadline();break;
  case BIF : mks_sched=schedule_by_importance();break;
  case DBS : mks_sched=schedule_by_DBS();break;
  case III : mks_sched=schedule_by_III(); 
  }
  return(mks_sched);
}


/* ============================================================================ */
void interpret(mks *mks_curr, systime_t running_time){
/* ============================================================================ */

  systime_t t1, P_time, E_time ; 
  int TheValue;
  int pid=mks_curr->identifier;
  int idn;
  systime_t exec_time;
  
#ifdef CONTROL_DEBUG
  passed_time=systime_get_time();/*comprobar unidades*/
#endif
  
  P_time=systime_gettime();

#ifdef LUIS_DEBUG
  fprintf(stderr,"\t(control.c:interpret) running_time: %lld  mks id:%s ksi id:%d\n",
	  running_time, 
	  mks_curr->name,
	  mks_curr->p_ks->KS->identifier);
#endif

  /*SendMessage(mks_curr->p_ks->KS->identifier,"KS executed by the control", 1);
    
    time_get_system_time(&TheAux1);
    fprintf(stderr,"Antes de ExecuteKSI : %ld%04ld\n",
    HI(TheAux1),LO(TheAux1));*/


  if (heuristic==DBS)
    TheValue = ExecuteKSI_dbs(mks_curr->p_ks->KS->identifier,running_time); /*preparar*/
  else TheValue = Level_Execute_Until(mks_curr->p_ks->KS->identifier, running_time,((in_agent *)mks_curr->mother)->in_agent_ident );    
  
  /* time_get_system_time(&TheAux1);
     fprintf(stderr,"Despues de ExecuteKSI : %ld%04ld\n",
     HI(TheAux1),LO(TheAux1));*/
  E_time=systime_gettime();/*revisar tiempos*/ 
  if (TheValue == LEVEL_ENDED ) {   
       /*** The KSI has finished its execution ***/

#ifdef CONTROL_DEBUG
    time_get_system_time(&t2);
    end_time= t2 - origin;
    fcrono = fopen(concro, "a+" );   
    for ( id = 0 ; id < number_of_agents ; id++ )
      if ( !strcmp( TASK[ id ], mks_curr->name ) )
	break ;
    /*** It has found the identifier used for the
     *   crono program for the agent we're managing
     ***/
    t2 =passed_time - origin;
    fprintf( fcrono, "EXEC %d %ld%04ld %ld%04ld \n", id, 
	     HI(t2), LO(t2),
	     HI(end_time), LO(end_time));
    fprintf( fcrono, "END %d %ld%04ld \n", id,HI(end_time),LO(end_time));
    fclose(fcrono);   
#endif
    
    if (heuristic==DBS){
      t1 = E_time - P_time;
      mks_curr->p_ks->KS->execution += t1;
      exec_time = mks_curr->p_ks->KS->execution;
      check_deadline(mks_curr);
      init_deadline = mks_curr->p_ks->KS->deadline;
      idn = mks_curr->identifier;
    }
    if (update_mks( mks_curr )){
      if (heuristic==DBS){
	if (mks_curr->state==NOT_EXECUTED){
	  if (check_deadline(mks_curr)) {
	    init_deadline=init_deadline<mks_curr->p_ks->KS->deadline ?
	      mks_curr->p_ks->KS->deadline : init_deadline;
	    update_rsa_deadlines();
	    in_first(&rsa, mks_curr );
	  }
	  else free_mks(mks_curr);
	  }
      }
      else in_ord(&rsa,mks_curr);
    }    
#ifdef CONTROL_DEBUG 
    if (mks_curr->type == SPORADIC ){
      fcrono = fopen( concro, "a" );
      time_get_system_time(&passed_time);
      t1= passed_time - origin;
      t2 = mks_curr->p_ks->KS->deadline + t1;
      fprintf( fcrono, "ACTI %d %ld%04ld %ld%04ld \n", id, 
	       HI(t1),LO(t1), HI(t2),LO(t2));
      fclose( fcrono );
    }
#endif
    
    if (heuristic==DBS){
      init_deadline = (Is_init_deadline < 0 ? 0 : init_deadline);
      
      /*init_deadline += reset_t_deliber(&rsa,idn,(exec_time + init_deadline));*/
    }
  }
  if ( TheValue == LEVEL_TIMEOUT ){
    fprintf(stderr,"\t(control.c:interpret) Unfinished \n");
    /*** The ksi has been paused ***/
    mks_curr->p_ks->KS->ks_deliber=0;
    in_ord(&rsa,mks_curr);
    update_paused(mks_curr, pid);
    /* KillKSI(mks_curr->p_ks->KS->identifier);*/
#ifdef CONTROL_DEBUG
    time_get_system_time(&t1);
    end_time = t1 - origin;
    fcrono = fopen(concro, "a+" );   
    for ( id = 0 ; id < number_of_agents ; id++ )
      if ( !strcmp( TASK[ id ], mks_curr->name ) )
	break ;
    /*** It has found the identifier used for the crono 
     *    program for the agent we're managing.
     ***/
    t2 = passed_time - origin;
    fprintf( fcrono, "EXEC %d %ld %ld \n", id, t2, end_time);   
    fclose(fcrono);   
#endif
  }    
  
}

