
#include "../../include/time.h"
#include "../include/dserver/est_datos.h"

extern systime_t control_slack;                   
extern systime_t real_time;       
extern systime_t end_time;

/**
 * This function should return the maximum slack time available according to the 
 *   global slack time that is in the [mandatory, dead] interval, or 0 if 
 *   the global slack time is lower than mandatory.
 *

void get_available(systime_t mandatory,systime_t dead, systime_t *t1)
{
 systime_t av, aw;

 real_time=systime_gettime();
 aw = mandatory + real_time;
 av = (end_time > aw)? end_time - aw : 0;
 if (dead < av) *t1 = dead;
  else *t1 = av;
}
*/

void get_available(systime_t mandatory,systime_t dead, systime_t *t1)
{
 systime_t av, aw;

 real_time=systime_gettime();
 aw = end_time - real_time;

 if (aw < mandatory)
   *t1 = (systime_t)0;
 else if (aw > dead)
   *t1 = dead;
 else *t1 = aw;
}


void get_real_t(mks *a_mks, systime_t t1, systime_t *t2)
{
  if (a_mks->p_ks->KS->duration <= t1)
    { 
    *t2=a_mks->p_ks->KS->duration;}
  else *t2 = 0;
}

void get_real_t_mod(mks *a_mks, systime_t t1, systime_t *t2)
{
  if (a_mks->p_ks->KS->duration <= t1)
    { 
    *t2=a_mks->p_ks->KS->duration;}
  else *t2 = t1;
}


int enough_time(systime_t mandatory)
{
 systime_t need_time;

 real_time=systime_gettime();
 
 need_time = real_time + mandatory;
 /*fprintf(stderr,"real %ld mandatory %ld %ld %ld\n",
	 real_time,mandatory,need_time,end_time);*/
 return( !(need_time >= end_time) );
}

/* ipg toadd
int set_end_point(systime_t end_point){
end_time = end_point;
}
*/



