/*

   FILE:
	dserver.h						

   Copyright (C) 1998-2003
        GTI-IA, DSIC, UPV


  This is free software;  you can  redistribute it  and/or modify it under
  terms of the  GNU General Public License as published  by the Free Soft-
  ware  Foundation;  either version 2,  or (at your option) any later ver-
  sion.  It is distributed in the hope that it will be useful, but WITH-
  OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  for  more details.  You should have  received  a copy of the GNU General
  Public License;  see file COPYING.  If not, write to  the Free Software
  Foundation,  59 Temple Place - Suite 330,  Boston, MA 02111-1307, USA.

*/

/*

  AUTHOR(S): A. Terrasa, C. Carrascosa, L. Hernández

  CREATION DATE: 2003-10-06

  CHANGELOG:


  DESCRIPTION:

    The DSERVER module (Deliberative Server) provides...

    This module exports a single function (sched_start), which is used
    from the application (main) Linux module. sched_start is called in
    order to initialize the deliberative server (including the main
    loop, the second-level scheduler and the event manager). Its
    arguments are two arrays containing the pointers to the functions
    executing the optional levels and their parameters, respectively.


*/


#ifndef __DSERVER_H
#define __DSERVER_H




#define MAX_LEVELS  64


int  DS_start(void);

void DS_stop(int status);



#endif //  __DSERVER_H
