/*

   FILE:
	init.h

   Copyright (C) 1998-2003
        GTI-IA, DSIC, UPV


  This is free software;  you can  redistribute it  and/or modify it under
  terms of the  GNU General Public License as published  by the Free Soft-
  ware  Foundation;  either version 2,  or (at your option) any later ver-
  sion.  It is distributed in the hope that it will be useful, but WITH-
  OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  for  more details.  You should have  received  a copy of the GNU General
  Public License;  see file COPYING.  If not, write to  the Free Software
  Foundation,  59 Temple Place - Suite 330,  Boston, MA 02111-1307, USA.

*/

/*

  AUTHOR(S): A. Terrasa

  CREATION DATE: 2003-10-16

  CHANGELOG:


  DESCRIPTION:

  The INIT module contains the initialization/cleanup of the different
  ARTIS modules, in either RT-Linux or Linux, which are *independent*
  of the application (that is, they contain the same actions for every
  possible application).

  In the case of RT-Linux, such functions will be the actual
  "init_module" and "cleanup_module" of the RT-Linux ARTIS main module
  (rtl_artis.o), and thus these functions are not *exported* to any
  other module (in fact, it's the other way around).

  But, in the case of the initialization/cleanup in Linux, since they
  are done inside the "linux_side" process, they have to be exported
  to the "application module".

*/


#ifndef __INIT_H
#define __INIT_H


// Visible functions:

int linux_artis_init (void);

int linux_artis_cleanup (void);


#endif // #ifndef __INIT_H
