/*!
  \file globals.h
  \date Time-stamp: <17-11-2004 23:35>
  \author M. Rebollo <mrebollo@dsic.upv.es>
  \version 0.2

  \brief Global definitions and data types for KDM
*/

#if !defined _KDMUSER_H_  && !defined _KDMMOD_H_ && !defined KDM_COMPILATION
# error "Never include <include/kdm/blackboard.h> to use KDM."
# error "Only public <kdm.h> files can be included directly."
#endif



#ifndef _GLOBALS_H_
#define _GLOBALS_H_

/*
  It doesn't work yet!! (12-11-2004)
  I'll try to solve it asap
  In the meantime, I won't use 64 bit word datatypes
*/
#ifndef MODULE
#include <stdint.h>
#else
#include <linux/types.h>
#endif


/*!
  \enum kdm_t Valid domains for static and temporal slots
*/

typedef enum _kdm_t { KDM_CHAR, 
		      KDM_INT,
		      KDM_UINT,
		      KDM_LONG,
		      KDM_ULONG,
		      KDM_INT64,
		      KDM_UINT64,
		      KDM_FLOAT, 
		      KDM_DOUBLE,
		      KDM_PTR,
		      KDM_ARRAY } kdm_t;
/*! 
  \def KDM_PRIMITIVE_TYPES
  \brief Number of different types that can be used in the KDM
*/
#define KDM_PRIMITIVE_TYPES   KDM_ARRAY+1



/* the longest representation for integer and real values
   must be ensured to guarantee its use for any external library */
typedef void* kdmtype;

/* kdm primitive datatype definition */
typedef char              kdmchar;
typedef int               kdmint;
typedef unsigned int      kdmuint;
typedef long int          kdmlong;
typedef unsigned long int kdmulong;
/*
    MRP: Till it works
typedef int64_t           kdmint64;
typedef uint64_t          kdmuint64;
*/
typedef float             kdmfloat;
typedef double            kdmdouble; 
typedef void*             kdmpointer;


/*!
  \union KDM_Value Stores the slot value depending on the data domain
*/
typedef union _value_t{
  kdmchar     c;
  kdmint      i;
  kdmuint     ui;
  kdmlong     l;
  kdmulong    ul;
  /*
    MRP: Till it works
  kdmint64    i64;
  kdmuint64   ui64;
  */
  kdmfloat    f;
  kdmdouble   d;
  kdmpointer  pt;   /* Used for an array or a generic pointer */
} KDM_Value;

#endif //_GLOBALS_H_
