/*!
  \file kdm.c
  \date Time-stamp: <16-11-2004 00:41>
  \author M. Rebollo <mrebollo@dsic.upv.es>
  \version 0.2

  \brief access functions to KDM information

*/

#ifdef MODULE
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/version.h>
#else
#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#endif //MODULE

#include "../../storage/include/storage.h"
#include "../include/kdm/kdm.h"


//Previously declared in blackboard.h
struct tbn_t tbn;


int 
//---------------------------------------------------
kdm_init(void)
//---------------------------------------------------
{
  int errorcode = 0;
  strcpy( tbn.name, "kdm" );
  tbn.stdata = NULL;
  
  errorcode = static_register_access();

  /*
#ifdef MODULE
  rtl_printf("(kdm.c) Name: %s\n", tbn.name);
#else
  fprintf(stderr, "(kdm.c) Name: %s\n", tbn.name);
#endif

#ifndef MODULE
  assert( Storage_Create( tbn.name, tbn.max_size, tbn.max_entities, &(tbn.stdata) ) != STORAGE_FAILURE ); 
#else 
  if (Storage_Create(tbn.name, tbn.max_size, tbn.max_entities, &(tbn.stdata))
      == STORAGE_FAILURE) {
    // ATB: Solucion rapida. Estudiar retorno erroneo
    rtl_printf("(rtl_kdm) Storage Creation failed\n");
    return -1;
  }
#endif

#ifndef MODULE
  assert( tbn.stdata != NULL );
#else 
  if ( tbn.stdata == NULL ) {
    // ATB: Solucion rapida. Estudiar retorno erroneo
    rtl_printf("(rtl_kdm) Storage Creation failed\n");
    return -1;
  }
#endif

#ifdef MODULE
  rtl_printf("(rtl_kdm.c) Storage stoid: %x\n", (unsigned int) tbn.stdata);
#else
  printf("(kdm.c) Storage stoid: %x\n", (unsigned int) tbn.stdata);
#endif
  */
  return errorcode;

} //kdm_init()


int 
//---------------------------------------------------
kdm_clean(void)
//---------------------------------------------------
{
#ifndef MODULE
  assert( tbn.stdata != NULL );
#else 
  if ( tbn.stdata == NULL ) {
    // ATB: Solucion rapida. Estudiar retorno erroneo
    return -1;
  }
#endif

  Storage_Destroy( tbn.name, tbn.stdata );
  return 0;
} //kdm_clean()







#ifdef MODULE

int 
//------------------------------------------------------
kdm_init_module(void)
//------------------------------------------------------
{
  return kdm_init();
} //kdm_init_module()


void 
//------------------------------------------------------
kdm_cleanup_module(void)
//------------------------------------------------------
{
  kdm_clean();
} //kdm_cleanup_module()



#endif //MODULE
