/*!
  \file events.c
  \date Time-stamp: <16-03-2005 00:41>
  \author M. Rebollo <mrebollo@dsic.upv.es>
  \version 0.3

  \brief internal access funtions to event management
*/


#include <assert.h>
#include <stdlib.h>
#include "../include/kdm/events.h"
#include "../include/kdm/static.h"



//---------------------------------------------------
// inline functions
//--------------------------------------------------- 


inline int 
//--------------------------------------------------- 
kdm_event_add( void* slot, int event, int imp ){
//--------------------------------------------------- 

  if( slot == NULL ) return -1;
  ((static_slot*)slot)->event |= event;
  ((static_slot*)slot)->imp = imp;
  
  return 0;

} //kdm_event_add()


inline int 
//--------------------------------------------------- 
kdm_event_release( void* slot, int event ){
//--------------------------------------------------- 

  if( slot == NULL ) return -1;
  ((static_slot*)slot)->event &= ~event; //1-complement of event

  return 0;

} //kdm_event_release()


inline int 
//--------------------------------------------------- 
kdm_event_set( void* slot, int event, int imp ){
//--------------------------------------------------- 
  
  if( slot == NULL ) return -1;
  ((static_slot*)slot)->event = event;
  ((static_slot*)slot)->imp = imp;
  
  return 0;

} //kdm_event_set()


