/*!
  \file kdm.c
  \date Time-stamp: <22-03-2005 13:45>
  \author M. Rebollo <mrebollo@dsic.upv.es>
  \version 0.2

  \brief access functions to KDM information

*/

#ifdef MODULE
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/version.h>
#else
#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#endif //MODULE

#include "../../storage/include/storage.h"
#include "../include/kdm/kdm.h"


#include "../../common/include/artis_conf.h"

#include "../../include/mutex.h"

//Previously declared in blackboard.h
struct tbn_t tbn;


int 
//---------------------------------------------------
kdm_init(void)
//---------------------------------------------------
{
  int errorcode = 0;

  /* Init the temporal belief network strucrure */
  strcpy( tbn.name, "kdm" );
  tbn.stdata = NULL;
  
  /* Regist the access functions to static information */ 
  errorcode = static_register_access();

  return errorcode;

} //kdm_init()


int 
//---------------------------------------------------
kdm_clean(void)
//---------------------------------------------------
{
#ifndef MODULE
  assert( tbn.stdata != NULL );
#else 
  if ( tbn.stdata == NULL ) {
    // ATB: Solucion rapida. Estudiar retorno erroneo
    return -1;
  }
#endif

  Storage_Destroy( tbn.name, tbn.stdata );

  return 0;

} //kdm_clean()







#ifdef MODULE

int 
//------------------------------------------------------
kdm_init_module(void)
//------------------------------------------------------
{

///  mutex_create( MUTEX_CONTROL, 

  return kdm_init();

} //kdm_init_module()


void 
//------------------------------------------------------
kdm_cleanup_module(void)
//------------------------------------------------------
{
  kdm_clean();
} //kdm_cleanup_module()



#endif //MODULE
