/***************************meta-rule_actions.h*******************************/
/*********************************20030415*************************************
 *      Functions implementing the actions in the Meta-Rules
 *
 *  There are also actions for Meta-Rules:
 *    - To activate an Attention Focus: 
 *        Through the function defined in meta-rule_store.c
 *             void ActivateAttentionFocus( int nAF, float fAttentDegree )
 *    - To deactivate an Attention Focus: 
 *        Through the function defined in meta-rule_store.c
 *             void DeactivateAttentionFocus( int nAF, float fAttentDegree )
 *    - To change the value of an slot (that will be a Meta-Reasoning slot):
 *        Through the function defined in kdm.c & rt_kdm.c
 *             int KDM_Set_Slot_Value( KDM_Handle pHnd, ... ) 
 ***/

#ifndef META_RULE_ACTIONS_H
#define META_RULE_ACTIONS_H

//#include "../control/include/decl4.0.h"  
    /*** For the Meta-Reasoning "slots":
    /***   - int heuristic;
     *         This should be called SLS - Second Level Scheduler current policy
     *     - float system_quality ;   
     *         IT WOULDN'T HAVE TO BE A FLOAT 
     *     - int nExecIS;     
     *         Number of times the IS has been executed 
     *     - float MaxQuality; 
     *     - int ReactivityDegree;   
     *         [0..100] 
     *          --> scheduler.c (cuando se puedan adelantar las partes finales)
     *     - int EventRate; 
     *          Max. number of events treated in a control cycle 
     *     - int LevelsCompleted; 
     *           Number of levels completed with the current scheduling policy 
     *     - int LevelsInterrupted;
     *           Number of levels interrupted with the current scheduling policy
     * More Meta - Slots needed: CurrentAttentionFocus 
     ***/


/*** This function inserts in the tsa the sporadic level indicated 
 *      by nLevelId
 ***/
extern void TriggerSporadicLevel( int nLevelId );


/*** Sets nReactDegree as the Reactivity Degree of the AA ***/
extern void SetReactivityDegree( int nReactDegree );

extern void SetPolicy( int nSlsPolicy );


/*** -> SetAttentionDegree fAttentionDegree --- ***/
extern void SetAttentionDegree ( float fAttentionDegree );


/*** -> SetBehaviour nBehav --- ***/
extern void SetBehaviour( int nBehav );

/*** ***/
extern void MetaRuleActionsInitialize(void);
#endif
