/********************* meta-rule_rehearsal.c ********************/ 
/*************************** 20030319 ***************************/  


/*  

   FILE:                                
    meta-rule_rehearsal.h 
                                    
   DESCRIPTION:                             
    Meta-Rule Store Rehearsal 

   Copyright (C) 2003
    Carlos Carrascosa Casamayor


  This is free software;  you can  redistribute it  and/or modify it under
  terms of the  GNU General Public License as published  by the Free Soft-
  ware  Foundation;  either version 2,  or (at your option) any later ver-
  sion.  It is distributed in the hope that it will be useful, but WITH-
  OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  for  more details.  You should have  received  a copy of the GNU General
  Public License;  see file COPYING.  If not, write to  the Free Software 
  Foundation,  59 Temple Place - Suite 330,  Boston, MA 02111-1307, USA.

*/


#include "meta-rule_store.h"
#include <stdio.h>

int main() {
    int nEvType, npSlot, nCond, nAct, nMetaRule, nAttFocus, i, nAux;

    printf("Rehearsal\n");

    InitMetaRuleStore();   
        /*** The CreateMetaRuleStore() function doesn't give initial values
         *        to the vars.
         ***/

    printf("I have created the Meta-Rule Store\n");
    
    nCond = GetEmptyCondNode();
    printf("And now, I have an empty Cond. Node\n");
    /*** Simple condition that checks if the value of the KDM slot with address
     *        333 is different to 25 (this value is of type int)
     ***/
    aregEmptyCondNode[nCond].regF1.nType = 1; /*** pSlot ***/
    aregEmptyCondNode[nCond].regF1.uniType.pSlot = (void *) 333;
    aregEmptyCondNode[nCond].nOp = 1; /*** <> ***/
    aregEmptyCondNode[nCond].regF2.nType = 3; /*** nFactor ***/
    aregEmptyCondNode[nCond].regF2.uniType.nFactor = 25;
    aregEmptyCondNode[nCond].pNext = -1;
    
    nAct = GetEmptyActNode();
    printf("And now, I have an empty Act. Node\n");
    /*** The action is to change the SLS Policy to the 3rd one ***/
    aregEmptyActNode[nAct].nAct = 4;  /*** SetPolicy ***/
    aregEmptyActNode[nAct].regArg1.nSlsPolicy = 3; 
    /*** For this kind of action, regArg2 is not considered ***/
    aregEmptyActNode[nAct].pNext = -1;

    /*** Creation of a Meta-Rule which is triggered by a modification of the 
     *        slot with address 333
     ***/
    printf("And now, I want an empty Meta-Rule\n"); 
    nMetaRule = CreateMetaRule ( MODIFICATION, (void *) 333, nCond, nAct );
    printf("And now, I have a whole Meta-Rule\n");
    
    nAttFocus = GetEmptyAttFocusNode();

    printf("I have an empty AttFocus. Node\n");

    InsertMetaRuleInAttFocus( nMetaRule, nAttFocus );
    
    printf("I have inserted the Meta Rule in the AttFocus.\n");

    ActivateAttentionFocus( nAttFocus, 1 );
    
    printf("I have activated the AttFocus.\n");

    printActiveAttFocus();
    
    printf("This seems to work before the freedom time\n");
    
    MetaRuleStoreFree();
    
    printf("This is the end of the world as we know it\n");
    
    getchar();
    
    return 1;
}
