/**************************meta-rules_interpret.h******************************/
/*********************************20030423*************************************/

#ifndef META_RULES_INTERPRET_H

#define META_RULES_INTERPRET_H

#include "../events/KDM_events.h"     /*** Definition of KDM_Event_T ***/
#include "meta-rule_store.h"
#include "meta-rule_actions.h"

/*** Evaluate the factor leaving the result in a double valor ***/
extern double EvalFactor ( regTypeFactor regFactor, KDM_Event_T regEvent );


/*** Evaluates the expression in aregEmptyCondNode[nCond] 
 *   It returns:
 *        - 0, if the expr. is evaluated to false.
 *        - <> 0, if the expr. is evaluated to true.
 ***/
extern int EvalExpr ( int nCond, KDM_Event_T regEvent );


/*** Executes the action in aregEmptyActNode[nAct] ***/
/*** Valid data combinations for the regActNode:
 *      nAct (int -> action code)     regArg1                regArg2
 *      0 -> Assign                   pSlot (relative ptr)   pExpr
 *      1 -> Function Call            nFunctId               ---
 *      2 -> TriggerSporadicLevel     nLevelId               ---
 *      3 -> SetReactivityDegree      nReactDegree           ---
 *      4 -> SetPolicy                nSlsPolicy             ---
 *      5 -> SetFocus                 nAttentionFocus        fFocusAttentDegree
 *      6 -> SetAttentionDegree       fAttentionDegree       ---
 *      7 -> SetBehaviour             nBehav                 ---
 *      8 -> KDM_Add_Event            pSlot                  iType       iImp (nAct from the 
 *                                                                            next regActNode)
 *      9 -> KDM_Release_Event        pSlot                  iType
 ***/
extern void ExecuteAction( int nAct, KDM_Event_T regEvent );


/*** Evaluates the condition and if it is true, executes the actions associated
 *      to the Meta Rule.
 *   It should receive also the KDM_Event_T received in the event as a parameter 
 ***/
extern void InterpretMR ( int nMetaRule, KDM_Event_T regEvent );


/*** It manages the event in regEvent evaluating as much as nMaxMR meta-rules
 *     associated to this event.
 *   It returns the number of MR it has found and executed.
 ***/
extern int ManageEvent ( KDM_Event_T regEvent, int nMaxMR );

#endif
