///
///  file: metaclass.c
///  date: Sun Sep 05 01:45:05 2004
///
///

#ifdef MODULE
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/version.h>
#include <rtl.h>
#else 
#include <stdio.h>
#include <stdlib.h>
#endif

#include "../../include/metaclass.h"

safeguard *pSafeguard;
MetaClass *pMetaClass;

int meta_kdm_create(void)
{
  // Creates the objects for the Meta-KDM
#ifdef MODULE
  if ((pSafeguard = 
       (safeguard *) Storage_Create_Object(tbn.stdata, 
			   sizeof(safeguard), 0)) == NULL) {
    rtl_printf("(rtl_metaclass) Error in creating the object KDM\n");
    ///#else
    ///    fprintf(stderr, "(userclass.c) Error in binding the object KDM\n");
    return -1;
  }
#endif

#ifdef MODULE
  if ((pMetaClass = 
       (MetaClass *) Storage_Create_Object(tbn.stdata, 
			   sizeof(MetaClass), 1)) == NULL) {
    rtl_printf("(rtl_metaclass) Error in creating the object Meta-KDM\n");
    return -1;
  }
#else
  pMetaClass = Storage_Get_Object( tbn.stdata, 1);
#endif

#ifdef MODULE
  rtl_printf("(rtl_metaclass) After Creating Meta-KDM Data: %p\n", 
	     (void *)pMetaClass);
#else
  printf("(metaclass.c) After Creating Meta-KDM Data: %p\n", (void *)pMetaClass);
#endif

  pMetaClass = Storage_Get_Address( tbn.stdata, pMetaClass );
				
  return 0;

} //meta_kdm_create()


int meta_kdm_destroy(void)
{
  // The space reserved in the Storage is freed automatically when destroyed

  return 0;
  //Frees the used memory
} //meta_kdm_destroy()

#ifdef MODULE
int metaclass_init_module( void ) {
  rtl_printf("(rtl_metaclass) Initializing meta-classes\n");
  meta_kdm_create();
  return 0;
}

void metaclass_cleanup_module (void) {
}
#endif
