/* file: metaclass.c
 generated from metaclass.xml

 PLEASE, DO NOT MODIFIY THIS FILE
*/


#ifdef MODULE
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/version.h>
#include <rtl.h>
#else
#include <stdio.h>
#include <stdlib.h>
#endif

#include <artis/include/metaclass.h>

MetaClass *pMetaClass;

int meta_kdm_load(void)
{
  // Creates the objects for the Meta-KDM
#ifdef MODULE
  if ((pMetaClass = (MetaClass *) Storage_Create_Object(tbn.stdata, sizeof(MetaClass), 0)) == NULL) 
{
    rtl_printf("(rtl_metaclass) Error in creating the object Meta-KDM
");
    return -1;
  }
#else
  pMetaClass = Storage_Get_Object( tbn.stdata, 0);
#endif

  pMetaClass = Storage_Get_Address( tbn.stdata, pMetaClass );

#ifdef MODULE  
  if (pMetaClass == NULL) {
    rtl_printf("(rtl_metaclass) ERROR
");
    return -1;
  }

  pMetaClass->systemQuality.type = KDM_INT;
  pMetaClass->systemQuality.value.i = 0;
  pMetaClass->systemQuality.event = NO_EVENT;

  pMetaClass->maxQuality.type = KDM_INT;
  pMetaClass->maxQuality.value.i = 100;
  pMetaClass->maxQuality.event = NO_EVENT;

  pMetaClass->slsPolicy.type = KDM_INT;
  pMetaClass->slsPolicy.value.i = 1;
  pMetaClass->slsPolicy.event = NO_EVENT;

  pMetaClass->reactivityDegree.type = KDM_INT;
  pMetaClass->reactivityDegree.value.i = 100;
  pMetaClass->reactivityDegree.event = NO_EVENT;

  pMetaClass->nExecDS.type = KDM_INT;
  pMetaClass->nExecDS.value.i = 0;
  pMetaClass->nExecDS.event = NO_EVENT;

  pMetaClass->eventRate.type = KDM_INT;
  pMetaClass->eventRate.value.i = 40;
  pMetaClass->eventRate.event = NO_EVENT;

  pMetaClass->levelsCompleted.type = KDM_INT;
  pMetaClass->levelsCompleted.value.i = 0;
  pMetaClass->levelsCompleted.event = NO_EVENT;

  pMetaClass->levelsInterrupted.type = KDM_INT;
  pMetaClass->levelsInterrupted.value.i = 0;
  pMetaClass->levelsInterrupted.event = NO_EVENT;

  pMetaClass->nCurrentBehavior.type = KDM_INT;
  pMetaClass->nCurrentBehavior.value.i = 0;
  pMetaClass->nCurrentBehavior.event = NO_EVENT;

  pMetaClass->nLastBehavior.type = KDM_INT;
  pMetaClass->nLastBehavior.value.i = -1;
  pMetaClass->nLastBehavior.event = NO_EVENT;

#endif

  return 0;

} //meta_kdm_load()


int meta_kdm_unload(void)
{
  // The space reserved in the Storage is freed automatically when destroyed
  return 0;
  //Frees the used memory
} //meta_kdm_unload()

#ifdef MODULE
int init_module( void ) {
  rtl_printf("(rtl_metaclass) Initializing meta-data
");
  meta_kdm_load();
  return 0;
}

void cleanup_module (void) {
}
#endif
