/*
  file: userclass.c
  generated from class.xml
  date: Tue Mar 22 20:14:46 2005

  PLEASE, DO NOT MODIFIY THIS FILE
*/

#ifdef MODULE
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/version.h>
#include <rtl.h>
#else 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#endif

#include "userclass.h"
#include <artis/common/include/artis_conf.h>
#include <artis/kdm/include/kdm.h>
#include <artis/storage/include/storage.h>

#ifdef MODULE
#define _create_object( class, instance )                     \
	instance = (class*)Storage_Create_Object( tbn.stdata,       \
			sizeof( class ), entityID++);	            \
	instance = Storage_Get_Address( tbn.stdata, instance );	 

#define _create_array( slot, item, size )                 \
	slot = (item*)Storage_Create_Object( tbn.stdata,       \
			sizeof( item ) * size, entityID++);	    

#define _create_pointer( slot, elem )                 \
	slot = (elem*)Storage_Create_Object( tbn.stdata,       \
			sizeof( elem ), entityID++);	            
#else
#define _create_object( class, instance )                     \
	instance = Storage_Get_Object( tbn.stdata, entityID++ );    \
	instance = Storage_Get_Address( tbn.stdata, instance );	    

#define _create_array( slot, item, size )                 \
	slot = Storage_Get_Object( tbn.stdata, entityID++);   

#define _create_pointer( slot, elem )                 \
	slot = Storage_Get_Object( tbn.stdata, entityID++);	            
#endif //MODULE	    

product *factory;

#define NUM_USER_ENTITIES	1


int user_kdm_load(void)
{
  int entityID;
#ifndef MODULE
  int i;
  int *pArray;

  i = 0; pArray = NULL;
#endif

  // Creates the objects for the robot in the KDM
#ifdef MODULE
  rtl_printf("(kdm.c) Name: %s\n", tbn.name);
#else
  fprintf(stderr, "(kdm.c) Name: %s\n", tbn.name);
#endif
  //This size have to be calculated from the user defined entities
  tbn.max_size = 1024;
  tbn.max_entities = ARTIS_LAST_NONUSER_ENTITY + NUM_USER_ENTITIES + 1;
 
  if( Storage_Create( tbn.name, tbn.max_size, 
	tbn.max_entities, &(tbn.stdata) ) == STORAGE_FAILURE) {
#ifdef MODULE
    rtl_printf("(rtl_kdm) Storage Creation failed\n");
#else
  fprintf(stderr, "(rtl_kdm) Storage Creation failed\n");
#endif
    return -1;
  }

#ifdef MODULE
  rtl_printf("(rtl_kdm.c) Storage stoid: %x\n", (unsigned int) tbn.stdata);
#else
  printf("(kdm.c) Storage stoid: %x\n", (unsigned int) tbn.stdata);
#endif

  entityID = ARTIS_LAST_NONUSER_ENTITY + 1;

  // Creates the objects for the robot in the KDM

  _create_object( product, factory );

#ifndef MODULE
  factory->stock.type = KDM_INT;
   factory->stock.value.i = 0;
   factory->stock.event = MODIFICATION;
  factory->stock.imp = 9;

  factory->counter.type = KDM_INT;
   factory->counter.value.i = 0;
   factory->counter.event = NO_EVENT;
  factory->counter.imp = -1;
#endif

  return 0;

} //user_kdm_load()

int user_kdm_unload(void)
{
  // The space reserved in the Storage is freed automatically when destroyed
  return 0;
} //user_kdm_unload()



//////////////////////////////////////////////////////
#ifdef MODULE
//////////////////////////////////////////////////////
int init_module( void ) {
  user_kdm_load();
  return 0;
} 

void cleanup_module( void ) {
}
#endif
/////////////////////////////////////////////////////
