/***************************************************

 ARTIS ATTENTION FOCUS DEFINITIONS

 File automatically generated by artis_mrules_parser
 Tue Mar 22 20:16:47 2005

 PLEASE DO NOT MODIFY THIS FILE

***************************************************/
/**
 *  \file attention_focus_definition.c
 *  \version 2.0
 *
 *  \brief Attention Focuses Definition 2.0
 *
 *
 *  This is free software;  you can  redistribute it  and/or modify it under
 *  terms of the  GNU General Public License as published  by the Free Soft-
 *  ware  Foundation;  either version 2,  or (at your option) any later ver-
 *  sion.  It is distributed in the hope that it will be useful, but WITH-
 *  OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for  more details.  You should have  received  a copy of the GNU General
 *  Public License;  see file COPYING.  If not, write to  the Free Software
 *  Foundation,  59 Temple Place - Suite 330,  Boston, MA 02111-1307, USA.
 *
*/

#include <stdio.h>
#include <artis/events/include/events.h>
#include <artis/include/meta_rule.h>
#include <artis/include/metaclass.h>
#include "userclass.h"
#include <artis/dserver/include/dserver/sls_policies.h>
#define MAXCONDITIONS 2
#define MAXACTIONS 7
#define MAXRULES 3
#define MAXAFS 3

/*****************AttentionFocusInit*********************************/
/**
 * \fn AttentionFocusInit
 *
 * Attention Focus Store (or Meta-Rule Store) initializing function
 */
int AttentionFocusInit(void) {
	int error, nCond[MAXCONDITIONS], nAct[MAXACTIONS], nAct8[MAXACTIONS], nMetaRule[MAXRULES], nAttFocus[MAXAFS];

	///if ((error = Meta_Rule_AF_Store_Creation( 2, 2, 7, 3, 3, 4 )) < 0 )
	if ((error = Meta_Rule_AF_Store_Creation( 2, 2, 7, 3, 3, 6 )) < 0 )
			return -1;
	else {
		fprintf(stderr, "(attention_focus_definition) Creating Meta-Rule Exprs. \n");

		// product.factory.stock >= 10
		while ((nCond[0] = Meta_Rule_Create_Expr( 4, 1, 3, &(factory->stock), 10) ) < 0 );


		// product.factory.stock <= 0
		while ((nCond[1] = Meta_Rule_Create_Expr( 5, 1, 3, &(factory->stock), 0) ) < 0 );

printf("Cond1: %d y cond2: %d\n", nCond[0], nCond[1]);

		// ATTENTION FOCUSES
	while ((nAttFocus[0] = Meta_Rule_Get_Empty_Att_Focus_Node()) < 0 );
	while ((nAttFocus[1] = Meta_Rule_Get_Empty_Att_Focus_Node()) < 0 );
	while ((nAttFocus[2] = Meta_Rule_Get_Empty_Att_Focus_Node()) < 0 );


		// ACTIONS
		// Trigger_Optional 1.0
		while ((nAct[0] = Meta_Rule_Create_Act( 10, 1.0, -1 ) ) < 0 );

		// SetBehavior 1
		while ((nAct[1] = Meta_Rule_Create_Act( 7, (1), -1 ) ) < 0 );
		// SetFocus 2 1
		while ((nAct[2] = Meta_Rule_Create_Act( 5, nAttFocus[2], 1.0 ) ) < 0 );
		// SetFocus 1 0
		while ((nAct[3] = Meta_Rule_Create_Act( 5, nAttFocus[1], 0.0 ) ) < 0 );
		// SetBehavior 0 
		while ((nAct[4] = Meta_Rule_Create_Act( 7, (0), -1 ) ) < 0 );
		// SetFocus 1 1
		while ((nAct[5] = Meta_Rule_Create_Act( 5, nAttFocus[1], 1.0 ) ) < 0 );
		// SetFocus 2 0
		while ((nAct[6] = Meta_Rule_Create_Act( 5, nAttFocus[2], 0.0 ) ) < 0 );

		// METARULES
		while (( nMetaRule[0] = Meta_Rule_Create ( CONSIDER_PERIODIC_AGENT , NULL, -1, nAct[0] )) < 0 );

		while (( nMetaRule[1] = Meta_Rule_Create ( MODIFICATION , &(factory->stock), nCond[0], nAct[1] )) < 0 );
		while (( Meta_Rule_Insert_Act ( nAct[2] , nMetaRule[1] )) <0 );
		while (( Meta_Rule_Insert_Act ( nAct[3] , nMetaRule[1] )) <0 );

		while (( nMetaRule[2] = Meta_Rule_Create ( MODIFICATION , &(factory->stock), nCond[1], nAct[4] )) < 0 );
		while (( Meta_Rule_Insert_Act ( nAct[5] , nMetaRule[2] )) <0 );
		while (( Meta_Rule_Insert_Act ( nAct[6] , nMetaRule[2] )) <0 );


		// ATTENTION FOCUSES
		while ( Meta_Rule_Insert_In_Att_Focus( nMetaRule[0], nAttFocus[0] ) < 0 );
		while ( Meta_Rule_Activate_Attention_Focus( nAttFocus[0], 1 ) < 0 );
		while ( Meta_Rule_Insert_In_Att_Focus( nMetaRule[1], nAttFocus[1] ) < 0 );
		while ( Meta_Rule_Activate_Attention_Focus( nAttFocus[1], 1 ) < 0 );
		while ( Meta_Rule_Insert_In_Att_Focus( nMetaRule[2], nAttFocus[2] ) < 0 );



		return 0;
	};
};
