#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/version.h>

#include <artis/include/artis_user.h>
#include <artis/include/artis_app.h>
#include <artis/include/kdm.h>
#include "userclass.h"

#include "KS/empty_ks.c"
#include "KS/produce_ks.c"
#include "KS/consume_ks.c"
MODULE_LICENSE("GPL");

#define N_TASKS    2
rt_task_t task[N_TASKS];

#define N_BEHAVS  2
rt_behav_task_t aTaskBeh[N_BEHAVS][N_TASKS];
rt_behav_t aBeh[N_BEHAVS];

void *fi_0 (void *dummy) 
{
  empty_ks();
  empty_ks();
  return (void *) 0;
}
void *ff_0 (void *dummy) 
{
  produce_ks();
  return (void *) 0;
}


void *fi_1 (void *dummy) 
{
  empty_ks();
  empty_ks();
  return (void *) 0;
}
void *ff_1 (void *dummy) 
{
  consume_ks();
  return (void *) 0;
}


int init_module(void) 
{

 struct task_create_info info[N_TASKS];
 int i;
//In-Agent definition

  info[0].identifier    = 1;
  info[0].priority      = 0;
  info[0].initial_function   = fi_0;
  info[0].initial_parameters = NULL;
  info[0].final_function     = ff_0;
  info[0].final_parameters   = NULL;
  info[0].has_optionals      = 1;
  info[0].offset        = (systime_t)  0;
  info[0].period        = (systime_t) 1000000000;
  info[0].deadline      = (systime_t) 1000000000;
  info[0].initial_wcet  = (systime_t) 200000;
  info[0].final_wcet    = (systime_t) 100000000;
  info[0].blocking_time = (systime_t)  0;

  info[1].identifier    = 2;
  info[1].priority      = 0;
  info[1].initial_function   = fi_1;
  info[1].initial_parameters = NULL;
  info[1].final_function     = ff_1;
  info[1].final_parameters   = NULL;
  info[1].has_optionals      = 1;
  info[1].offset        = (systime_t)  0;
  info[1].period        = (systime_t) 1000000000;
  info[1].deadline      = (systime_t) 1000000000;
  info[1].initial_wcet  = (systime_t) 200000;
  info[1].final_wcet    = (systime_t) 100000000;
  info[1].blocking_time = (systime_t)  0;

 for ( i = 0; i < N_TASKS; i++ )
   rtl_task_create (&task[i], &info[i]);

//behavior definition
 rtl_behav_create ( &(aBeh[0]), aTaskBeh[0], 1, &(task[0]));
 rtl_behav_create ( &(aBeh[1]), aTaskBeh[1], 1, &(task[1]));
 rtl_start_application();

 return 0;
}


void cleanup_module(void) 
{
rtl_end_application();
}
