
/*

   FILE:
	time.h						

   Copyright (C) 1998-2003
        GTI-IA, DSIC, UPV


  This is free software;  you can  redistribute it  and/or modify it under
  terms of the  GNU General Public License as published  by the Free Soft-
  ware  Foundation;  either version 2,  or (at your option) any later ver-
  sion.  It is distributed in the hope that it will be useful, but WITH-
  OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  for  more details.  You should have  received  a copy of the GNU General
  Public License;  see file COPYING.  If not, write to  the Free Software
  Foundation,  59 Temple Place - Suite 330,  Boston, MA 02111-1307, USA.

*/

/*

  AUTHOR(S): A. Terrasa

  CREATION DATE: 2003-10-06

  CHANGELOG:


  DESCRIPTION:

    This include exports the TIME interface to all the parts of ARTIS
    which need time access (including the user).

    In both cases, time are measured as a linear (long long) variable
    in which time is expressed in nanoseconds. This is the natural
    time unit in RT-Linux, but not in Linux. As a result, an explicit
    function for consulting the current time has to be provided to the
    "linux_side" process, while in RT-Linux, the original function is
    used (altough we have renamed it, in order to present a common
    API).

*/


// All the definitions are here:
#include "../../include/time.h"

